传送门

题意:

  有 n 个数 (1 ~ n) 分给了三个人 a, b, c; 其中 a 有 k1 个, b 有 k2 个, c 有 k3 个。

  现在问最少需要多少操作,使得 a 中所有数 是 1 ~ n 的一个前缀;

  c 中所有数 是 1 ~ n 的一个后缀。 剩下的都在 b 手上。

  每次操作可以让一个人手上的一个数给另一个人。

解: 简单 DP ; 显然就是问你 把  1 ~ n 分成三段的最少花费。

  你把 第一个人 最初拥有的数, 所在的桶 定义为 0;

  第二个人的为1, 第三个人的为2。

  然后你就可以 DP 了;

  dp[ i ][ 0 ] 就代表, 你的 第一个人取 1 ~ i 的花费。

  dp[ i ][ 1 ] 就表示, 第一个人 拿了 1 ~ i 的前缀 1 ~ pos 部分, 第二个人拿了, 剩下的 pos ~ i 部分的最少花费。

  dp[ i ][ 2 ] 类似。 看代码的式子应该就懂了。

#include <bits/stdc++.h>
#define LL long long
#define rep(i, j, k) for(int i = j; i <= k; i++)
#define dep(i, j, k) for(int i = k; i >= j; i--)
#define INF 0x3f3f3f3f
#define inf 0x3f3f3f3f3f3f3f3f
#define mem(i, j) memset(i, j, sizeof(i))
#define pb push_back
using namespace std; const int N = 2e5 + ;
int A[N];
int dp[N][];
int main() { int a, b, c; scanf("%d %d %d", &a, &b, &c);
int n = a + b + c;
for(int i = ; i <= a; i++) {
int x; scanf("%d", &x); A[x] = ;
}
for(int i = ; i <= b; i++) {
int x; scanf("%d", &x); A[x] = ;
}
for(int i = ; i <= c; i++) {
int x; scanf("%d", &x); A[x] = ;
}
for(int i = ; i <= n; i++) {
dp[i][] = dp[i - ][] + (A[i] != ? : );
dp[i][] = min(dp[i - ][], dp[i - ][]) + (A[i] != ? : );
dp[i][] = min(dp[i - ][], min(dp[i - ][], dp[i - ][])) + (A[i] != ? : );
}
printf("%d\n", min(dp[n][], min(dp[n][], dp[n][])));
return ;
}

官方解, 思维 + 贪心。

  我们假设三个人的数编号为 1 2 3

  首先, 假设我们定了 L, R。 就是说, 1 ~ L 这一段是 第一个人的, L ~ R 这一段是第二个人的。

  R ~ n 这一段是第三个人的。 那么, 你若确定了 L, R。  那么你的 答案, 就是固定的。

  我们假设  cnt[ L ][ i ] 表示 1 ~ L 这一段 是 i 个人的数的个数。

  我们假设 1 ~ L 这一段为 L,   L ~ R 这一段为 M 。  R ~ n 这一段为 R

  那么答案就是 cnt[ L ][ 2 ] + cnt[ L ][ 3 ] + cnt[ M ][ 1 ] + cnt[ M ][ 3 ] + cnt[ R ][ 1] + cnt[ R ][ 2 ];

  对吧。 那现在, 要是我们确定了 R 这个点。 然后, L 应该在什么位置 才是最优的呢。

  假设R 确定了。 那么 cnt[ L ][ 3 ] + cnt[ M ][ 3 ] , cnt[ R ][ 1 ] , cnt[ R ][ 2 ] 全都确定了嘛。

  那么还差 cnt[ L ][ 2 ] 和, cnt[ M ][ 1 ] 没有确定嘛。 那你想要 这两个值 尽可能的小嘛。

  那么就是 你希望, 1 ~ L 这一段中 2 的数 的个数尽可能少, L ~ R 这一段中 1 的数的个数尽可能少。

  那也可以说成, 你 1 ~ L 这一段中, 1 的个数尽可能的多, 2的个数尽可能的少嘛。

  因为你 1 ~ L 中 1 的个数尽可能多的话呢, 你 L ~ R 这一段中 1 的个数就自然小了嘛。

  那不就是 cnt[ L ][ 1 ] - cnt[ L ][ 2 ] 最大的时候 的位置, 就是 L 的位置吗。

  那么, 我们枚举  R, 再维护一个 cnt[ L ][ 1 ] - cnt[ L ][ 2 ] 的最大值。

  就可以确定 R 在这个点时的  最小答案了。

  我们假设 cnt[ L ][ 1 ] - cnt[ L ][ 2 ] 的最大值为 ma

  那么我们现在 让 R ~ n 这一段为 R, 1 ~ R 这一段为 LL 。

  那么答案就是 cnt[ R ][ 1 ] + cnt[ R ][ 2 ] + cnt[ LL ][ 3 ] + cnt[ LL ][ 1 ] - ma;

  就是答案了。 cnt[ LL ][ 1 ]  -  ma。  这一段代表的东西就是。

  你 ma 这个值是在最优的 L 处取得的嘛。

  那就是, 1 ~ R 这一段的所有的 1 减去,你 1 ~ L 这一段的不需要动的1嘛 。

  那得到的就是 L ~ R 这一段 1 的个数。

  再加上 你 1 ~ L 这一段的 2 的个数嘛。  那就刚好是 前面的 cnt[ L ][ 2 ] + cnt[ M ][ 1 ]。

  

#include <bits/stdc++.h>
#define LL long long
using namespace std;
const int N = 2e5 + ;
int pos[N];
int cntR[];
int cntL[];
int main() {
int a, b, c; scanf("%d %d %d", &a, &b, &c);
int n = a + b + c;
for(int i = ; i <= a; i++) {
int x; scanf("%d", &x);
pos[x] = ;
}
for(int i = ; i <= b; i++) {
int x; scanf("%d", &x);
pos[x] = ;
}
for(int i = ; i <= c; i++) {
int x; scanf("%d", &x);
pos[x] = ;
}
for(int i = ; i <= n; i++) {
cntR[pos[i]]++;
}
/// 整段都是 3 的。
int ans = cntR[] + cntR[];
int ma = ;
for(int i = ; i <= n; i++) {
cntL[pos[i]]++;
cntR[pos[i]]--;
ma = max(ma, cntL[] - cntL[]);
int tmp = cntR[] + cntR[] + cntL[] + cntL[] - ma;
ans = min(ans, tmp);
}
printf("%d\n", ans);
return ;
}

  

E. The Contest ( 简单DP || 思维 + 贪心)的更多相关文章

  1. hdu 1257 && hdu 1789(简单DP或贪心)

    第一题;http://acm.hdu.edu.cn/showproblem.php?pid=1257 贪心与dp傻傻分不清楚,把每一个系统的最小值存起来比较 #include<cstdio> ...

  2. codeforce1029B B. Creating the Contest(简单dp,简单版单调栈)

    B. Creating the Contest time limit per test 1 second memory limit per test 256 megabytes input stand ...

  3. codeforces Gym 100500H A. Potion of Immortality 简单DP

    Problem H. ICPC QuestTime Limit: 20 Sec Memory Limit: 256 MB 题目连接 http://codeforces.com/gym/100500/a ...

  4. 『简单dp测试题解』

    这一次组织了一场\(dp\)的专项考试,出了好几道经典的简单\(dp\)套路题,特开一篇博客写一下题解. Tower(双向dp) Description 信大家都写过数字三角形问题,题目很简单求最大化 ...

  5. luoguP1281 书的复制 DP,贪心

    luoguP1281 书的复制 链接 https://www.luogu.org/problemnew/show/P1281 思路 简单dp,输出方案. 很明显dp记录路径对不对? 恭喜你死了. 求出 ...

  6. Codeforces Round #302 (Div. 2) C. Writing Code 简单dp

    C. Writing Code Time Limit: 20 Sec  Memory Limit: 256 MB 题目连接 http://codeforces.com/contest/544/prob ...

  7. 洛谷 - P1004 - 方格取数 - 简单dp

    https://www.luogu.org/problemnew/show/P1004 这道题分类到简单dp但是感觉一点都不简单……这种做两次的dp真的不是很懂怎么写.假如是贪心做两次,感觉又不能证明 ...

  8. HDU 5375 Gray code (简单dp)

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5375 题面: Gray code Time Limit: 2000/1000 MS (Java/Oth ...

  9. 4.15 每周作业 —— 简单DP

    免费馅饼 Time Limit : 2000/1000ms (Java/Other)   Memory Limit : 65536/32768K (Java/Other) Total Submissi ...

随机推荐

  1. 软件模拟IIC实现EEPROM

    ....妈的太难.    反正就是控制引脚的高低电平 实现数据的读取....参考 I2C的协议层和物理层的那个几个图,个个信号产生的电平 自己看源码去把. 头疼

  2. go if 判断 完成随机分数的评级

    1 go中 所有的大括号要跟在 当前语句的后面不能换行 例如: if a>0  { func getUser(){ for { 2关于随机分数的生成 种子的设置放到循环中会是重复的数字,这是可以 ...

  3. MySQL5.7主从同步配置

    主从同步,将主服务器(master)上的数据复制到从服务器(slave). 应用场景 读写分离,提高查询访问性能,有效减少主数据库访问压力. 实时灾备,主数据库出现故障时,可快速切换到从数据库. 数据 ...

  4. Unity中的Character Controller

    Unity中默认提供了一个Character Controller的组件用于实现角色控制,一个3D的游戏物体,可以直接添加.Character Controller会自动模拟出Capsule Coll ...

  5. css3 transform实现水平和垂直居中

    代码如下: <!DOCTYPE html> <html lang="en"> <head> <meta charset="UTF ...

  6. element-ui重置表单并清除校验的方法

    this.$refs['activityForm'].resetFields(); 只会重置之前表单的内容,并不会清空 只需在关闭弹框的cancel方法中写上重置表单的方法即可 cancel() { ...

  7. php文件包含漏洞 file inclusion vulnerability

    0x00 何为文件包含漏洞 开发人员如果在写类似include "a.php"的代码时,如果将a.php写成了可变的值,那么就可以在上面做文章,举个理想的例子: <? inc ...

  8. libssh

    1.SSH概念 ssh(secure shell),安全外壳协议,由IETF的网络小组所制定.ssh为建立在应用层基础上的安全协议.SSH是目前较可靠,专为远程登录会话和其他网络服务提供安全性的协议. ...

  9. PyQt5多个GUI界面设计

    版权声明:本文为博主原创文章,转载 请注明出处:https://blog.csdn.net/sc2079/article/details/90454379 - 写在前面 本科毕业设计终于告一段落了.特 ...

  10. 【python】发送邮件,含附件

    def send_mail(_user,_pwd,_to): # f = open(file_new,'rb') # mail_body = f.read() # f.close() # 读取最新测试 ...